Bug Hunting Session
Bug 39748 - [EasyHack] Cleanup extensions list
Summary: [EasyHack] Cleanup extensions list
Status: CLOSED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: Other All
: medium normal
Assignee: David Tardon
URL:
Whiteboard:
Keywords: difficultyBeginner, easyHack, skillScript
Depends on:
Blocks:
 
Reported: 2011-08-02 02:01 UTC by Björn Michaelsen
Modified: 2015-12-15 16:24 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments
First mockup for extension filtering (53.88 KB, image/png)
2011-11-20 02:26 UTC, Olivier Hallot
Details
patch to clean extensions list (14.84 KB, patch)
2011-11-28 05:09 UTC, Olivier Hallot
Details
fix for fdo39748, part II (2.75 KB, patch)
2011-11-28 16:39 UTC, Olivier Hallot
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Björn Michaelsen 2011-08-02 02:01:03 UTC
==== Cleanup extensions list ====

'''Background:''' Since we now bundle lots of languages, the extension list
Tools->Extension manager is stuffed with things that cannoy be removed, which
is annoying. We should categorise the extensions, and filter out the built-in
ones by default. This means adding a check-button to:
desktop/source/deployment/gui/dp_gui_dialog2.src
desktop/source/deplyoment/gui/dp_gui_extlistbox.*
And adding some simple filtering so people see the extensions they
added themselves.

'''Skills:''' C++, common sense (.src), build
Comment 1 Caolán McNamara 2011-08-20 14:12:41 UTC
caolanm->dtardon: didn't you have some ideas around e.g. not showing "bundled" (as opposed to shared and user) extensions in this list ? At least not by default
Comment 2 Olivier Hallot 2011-11-20 02:26:46 UTC
Created attachment 53698 [details]
First mockup for extension filtering

First mockup for extension filtering
Comment 3 Olivier Hallot 2011-11-20 02:27:44 UTC
I gave a try to solve this bug and I have some questions on UX for it. Looking
into this first mockup attached.

1) I chose to use checkboxes so that filtering can display none, one, two or
three categories. A group of radio buttons will display one category
exclusively, and could make the search for an extension more difficult.

2) Either we implement an event upon changing the state of one of the
checkboxes or we add a "Filter" button on the right to start the filtering
(easier for me). What would be the prefered approach? The Bundled checkbox is
unmarked by default.
Comment 4 Caolán McNamara 2011-11-21 01:34:22 UTC
I wonder if it makes sense to just automatically restrict the extension management dialog to *just* the user extensions, i.e. skip showing the bundled and system ones altogether and not have any toggles to show them and require use of the standlone extension admin tools to list them.

Maybe ask the ux design team for their opinion on this ?
Comment 5 David Tardon 2011-11-21 21:59:25 UTC
A volunteer, excellent! So I am not going to have to do it myself after all :)

dtardon->olivier.hallot: I agree with Caolán that there is no need to overdo this. IMHO it makes perfect sense to not display bundled extensions at all (even if Rene disagrees :) In fact, I would argue that they are actually part of the application and it just happened they are distributed as extensions. We do not present config. manager or the internal spell checker in the extension list either, do we? :) But I would prefer that shared extensions remain displayed. One can still manipulate them if one has sufficient rights and I can imagine that some admins might prefer a GUI tool for that.

E.g., for removal,

unopkg gui

, find the extension and click on Remove button vs.

unopkg list --shared

find the extension in the listing (which might be several pages long and most of it is cruft nobody but developers is interested in), copy or remember an insanely long identifier and run

unopkg remove --shared <identifier>

:)

Last but not least, I suppose there is still a number of Windows boxes where the user does not have separate admin account, so the difference between user and shared extensions is just nominal.
Comment 6 Caolán McNamara 2011-11-22 01:18:59 UTC
The other possibility is that 
tools->extensions shows just the users extensions. 
while the stand alone unopkg gui shows all of them.
Comment 7 Olivier Hallot 2011-11-23 11:26:46 UTC
HI folks

some thoughts

1) There are legions of mouse-movers admins who get scared with a command prompt. I can't expect I'll have a genius administrating a LO deployment.: 

* leave  the GUI for admins

2) OTOH, there are users that are clever and want to see what is going on in their machine (cf René). What if an extension is advertised in a site and happens to be already bundled or shared in his default installation?....

* Show me the bundled and shared extensions as well.

3) One issue that is hurting us in the GUI is that bundled and shared extensions are not easy to distinguish one from other.

*Suggestion: bundled extension should have a red padlock icon, or a light red background table entry in GUI

4) I propose to change the label “bundled” to “From Installation” or such, because “bundled” does not say in layman words what is this about.

And guys, don't hold your breath, I am no C++ dev, I am lurking at the code and doing my best. If that is urgent, please take over.
Comment 8 Olivier Hallot 2011-11-28 05:09:35 UTC
Created attachment 53900 [details]
patch to clean extensions list
Comment 9 Olivier Hallot 2011-11-28 16:39:16 UTC
Created attachment 53919 [details]
fix for fdo39748, part II

Code cleanup and better listbox size calculation
Comment 10 David Tardon 2011-11-29 05:18:32 UTC
Yeah, the patch(es) looks good, but I thought the main point of this whole excercise was to hide the bundled extensions from user (e.g., do not show them by default)? I will commit it with that one change.

Btw, it has not been FIXED yet (i.e., the code is not in git :)
Comment 11 David Tardon 2011-11-29 05:26:15 UTC
Ah, I see Michael committed it already...
Comment 12 Robinson Tryon (qubit) 2015-12-15 16:24:54 UTC
Migrating Whiteboard tags to Keywords: (EasyHack DifficultyBeginner SkillScript )
[NinjaEdit]